Imports System.Drawing.Imaging

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make a bitmap.
        Const WID As Integer = 200
        Dim bm As New Bitmap(WID, WID)

        ' Find the WMF file's path and delete the file if it exists.
        Dim path_name As String = Application.StartupPath
        If path_name.EndsWith("\bin") Then path_name = path_name.Substring(0, path_name.Length - 4)
        Dim file_name As String = path_name & "\test.wmf"
        If Len(Dir$(file_name)) > 0 Then Kill(file_name)

        ' Make a Graphics object so we can use its hDC as a reference.
        Using me_gr As Graphics = Me.CreateGraphics
            Dim me_hdc As IntPtr = me_gr.GetHdc

            ' Make the Metafile, using the reference hDC.
            Dim bounds As New RectangleF(0, 0, WID, WID)
            Using mf As New Metafile(file_name, me_hdc, _
                bounds, MetafileFrameUnit.Pixel)
                me_gr.ReleaseHdc(me_hdc)

                ' Make a Graphics object and draw.
                Using gr As Graphics = Graphics.FromImage(mf)
                    gr.PageUnit = GraphicsUnit.Pixel
                    gr.Clear(Color.LightGray)
                    Using thick_pen As New Pen(Color.Red, 5)
                        gr.DrawEllipse(thick_pen, bounds)
                        thick_pen.Color = Color.Green
                        gr.DrawLine(thick_pen, 0, 0, WID, WID)
                        thick_pen.Color = Color.Blue
                        gr.DrawLine(thick_pen, WID, 0, 0, WID)
                    End Using
                End Using ' gr
            End Using ' mf

            ' Reload the metafile and copy it into a Bitmap.
            Using mf As New Metafile(file_name)
                Using gr As Graphics = Graphics.FromImage(bm)
                    Dim dest_bounds As New RectangleF(0, 0, WID, WID)
                    Dim source_bounds As New RectangleF(0, 0, WID + 1, WID + 1)
                    gr.DrawImage(mf, bounds, source_bounds, GraphicsUnit.Pixel)
                    picOrig.SizeMode = PictureBoxSizeMode.AutoSize
                    picOrig.Image = bm
                End Using ' gr
            End Using ' mf

            ' Redisplay the result shrunk by 50%.
            Using mf As New Metafile(file_name)
                picSmall.SetBounds( _
                    picOrig.Right + 10, picOrig.Top, _
                    picOrig.Width \ 2, picOrig.Height \ 2)
                bm = New Bitmap( _
                    picSmall.ClientSize.Width, _
                    picSmall.ClientSize.Height)
                Using gr As Graphics = Graphics.FromImage(bm)
                    Dim source_bounds As New RectangleF(0, 0, WID + 1, WID + 1)
                    gr.ScaleTransform(0.5, 0.5)
                    gr.DrawImage(mf, bounds, source_bounds, GraphicsUnit.Pixel)
                    picSmall.Image = bm
                    gr.Dispose()
                End Using ' gr
            End Using ' mf
        End Using ' me_gr
    End Sub
End Class
